/*
Zadatak 3 – Cezarova šifra

https://hr.wikipedia.org/wiki/Cezarova_%C5%A1ifra

Šifra zamjene u kojoj se svako slovo otvorenog teksta zamjenjuje odgovarajućim slovom abecede, pomaknutim za određeni broj mjesta.
Npr. s pomakom 3, A se zamjenjuje slovom D, B slovom E, itd.
Ova metoda je dobila ime po Juliju Cezaru, koji ju je koristio za razmjenu poruka sa svojim generalima.
Kao i sve ostale šifre jednostavne abecedne zamjene, Cezarova šifra lako se razbija i u praksi ne pruža nikakvu sigurnost u komunikaciji.

U prvom redu ulaza zadan je izvorni niz znakova maksimalne duljine 100 znakova.
U drugom redu zadan je pomak P kao cijeli broj 0≤P≤25. 
Radi jednostavnosti u nizovima ćemo koristiti samo velika slova engleske abecede (A-Z).
U jedinom retku izlaza treba ispisati sifrirani niz znakova.

Primjer:
ULAZ:
Unesite niz: ABC
Unesite pomak: 1

IZLAZ:
Kodirani niz je: BCD
*/

#include <stdio.h>

int main() {
    char niz[100+1];
    int pomak;
    int i;
    
    printf("Unesite niz: ");
    scanf(" %[^\n]", niz);//unosimo niz do enter-a
    
    do{
        printf("Unesite pomak: ");
        scanf("%d", &pomak);
    } while( (pomak<0) || (pomak>25) );//unosimo pomak dok nije u intervalu [0,25]
    
    for(i=0; niz[i]!='\0'; i++) {//do kraja niza, tj. do znaka '\0'
        if( (niz[i]>='A')&&(niz[i]<='Z') ) {//ako je znak veliko slovo
            niz[i] += pomak;//pomicemo znak za pomak
            
            if( niz[i]>'Z' ) {//ako je znak nakon pomaka izasao izvan intervala ['A','Z'] potrebno ga je vratiti
                niz[i] = niz[i] - 26;//vracamo znak unutar intervala, koristimo -26 jer je razlika sljedeceg znaka ('Z'+1) do 'A' jednaka 26
            }
        }
    }
    
    printf("Kodirani niz je: %s\n", niz);//ispisujemo niz
    
    return 0;
}

//Napravljeno u sklopu Radionice osnova programiranja u C-u u organizaciji Informatičke udruge Futura
//Licenca: http://creativecommons.org/licenses/by-nc-sa/3.0/hr/